Index: /palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4399)
+++ /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4400)
@@ -25,58 +25,65 @@
 ! -----------------
 ! $Id$
+! Revision of the module:
+! - revised input from NetCDF setup file
+! - parallel NetCDF output via data-output module ( Tobias Gronemeier )
+! - variable attributes added
+! - further variables defined
+!
+! 4346 2019-12-18 11:55:56Z motisi
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
-! 
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4226 2019-09-10 17:03:24Z suehring
 ! Netcdf input routine for dimension length renamed
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
 ! Replace function get_topography_top_index by topo_top_ind
-! 
+!
 ! 3988 2019-05-22 11:32:37Z kanani
 ! Add variables to enable steering of output interval for virtual measurements
-! 
+!
 ! 3913 2019-04-17 15:12:28Z gronemeier
 ! Bugfix: rotate positions of measurements before writing them into file
-! 
+!
 ! 3910 2019-04-17 11:46:56Z suehring
 ! Bugfix in rotation of UTM coordinates
-! 
+!
 ! 3904 2019-04-16 18:22:51Z gronemeier
 ! Rotate coordinates of stations by given rotation_angle
-! 
+!
 ! 3876 2019-04-08 18:41:49Z knoop
 ! Remove print statement
-! 
+!
 ! 3854 2019-04-02 16:59:33Z suehring
 ! renamed nvar to nmeas, replaced USE chem_modules by USE chem_gasphase_mod and
-! nspec by nvar 
-! 
+! nspec by nvar
+!
 ! 3766 2019-02-26 16:23:41Z raasch
 ! unused variables removed
-! 
+!
 ! 3718 2019-02-06 11:08:28Z suehring
 ! Adjust variable name connections between UC2 and chemistry variables
-! 
+!
 ! 3717 2019-02-05 17:21:16Z suehring
 ! Additional check + error numbers adjusted
-! 
+!
 ! 3706 2019-01-29 20:02:26Z suehring
 ! unused variables removed
-! 
+!
 ! 3705 2019-01-29 19:56:39Z suehring
 ! - initialization revised
 ! - binary data output
 ! - list of allowed variables extended
-! 
+!
 ! 3704 2019-01-29 19:51:41Z suehring
 ! Sampling of variables
-! 
+!
 ! 3473 2018-10-30 20:50:15Z suehring
 ! Initial revision
@@ -85,29 +92,45 @@
 ! --------
 ! @author Matthias Suehring
+! @author Tobias Gronemeier
 !
 ! Description:
 ! ------------
-!> The module acts as an interface between 'real-world' observations and 
+!> The module acts as an interface between 'real-world' observations and
 !> model simulations. Virtual measurements will be taken in the model at the
-!> coordinates representative for the 'real-world' observation coordinates. 
+!> coordinates representative for the 'real-world' observation coordinates.
 !> More precisely, coordinates and measured quanties will be read from a
-!> NetCDF file which contains all required information. In the model, 
+!> NetCDF file which contains all required information. In the model,
 !> the same quantities (as long as all the required components are switched-on)
 !> will be sampled at the respective positions and output into an extra file,
-!> which allows for straight-forward comparison of model results with 
-!> observations. 
+!> which allows for straight-forward comparison of model results with
+!> observations.
 !>
-!> @todo list_of_allowed variables needs careful checking
-!> @todo Check if sign of surface fluxes for heat, radiation, etc., follows
-!>       the (UC)2 standard 
-!> @note Fluxes are not processed
+!> @todo Check why there is an error when _FillValue attributes are added via
+!>       dom.
+!> @todo Output of character variable station_name (dom hasn't this feature
+!>       yet implemented).
 !------------------------------------------------------------------------------!
  MODULE virtual_measurement_mod
 
     USE arrays_3d,                                                             &
-        ONLY:  q, pt, u, v, w, zu, zw
+        ONLY:  dzw,                                                            &
+               exner,                                                          &
+               hyp,                                                            &
+               q,                                                              &
+               ql,                                                             &
+               pt,                                                             &
+               rho_air,                                                        &
+               u,                                                              &
+               v,                                                              &
+               w,                                                              &
+               zu,                                                             &
+               zw
 
     USE basic_constants_and_equations_mod,                                     &
-        ONLY:  pi
+        ONLY:  convert_utm_to_geographic,                                      &
+               degc_to_k,                                                      &
+               magnus,                                                         &
+               pi,                                                             &
+               rd_d_rv
 
     USE chem_gasphase_mod,                                                     &
@@ -116,98 +139,175 @@
     USE chem_modules,                                                          &
         ONLY:  chem_species
-        
+
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, dz, humidity, io_blocks, io_group, neutral,      &
-               message_string, time_since_reference_point, virtual_measurement
+        ONLY:  air_chemistry,                                                  &
+               child_domain,                                                   &
+               coupling_char,                                                  &
+               dz,                                                             &
+               end_time,                                                       &
+               humidity,                                                       &
+               message_string,                                                 &
+               neutral,                                                        &
+               origin_date_time,                                               &
+               rho_surface,                                                    &
+               surface_pressure,                                               &
+               time_since_reference_point,                                     &
+               virtual_measurement,                                            &
+               write_binary
 
     USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point
-        
+        ONLY:  cpu_log,                                                        &
+               log_point
+
+    USE data_output_module
+
     USE grid_variables,                                                        &
-        ONLY:  dx, dy
+        ONLY:  ddx,                                                            &
+               ddy,                                                            &
+               dx,                                                             &
+               dy
 
     USE indices,                                                               &
-        ONLY:  nzb, nzt, nxl, nxr, nys, nyn, nx, ny, topo_top_ind,             &
+        ONLY:  nbgp,                                                           &
+               nzb,                                                            &
+               nzt,                                                            &
+               nxl,                                                            &
+               nxlg,                                                           &
+               nxr,                                                            &
+               nxrg,                                                           &
+               nys,                                                            &
+               nysg,                                                           &
+               nyn,                                                            &
+               nyng,                                                           &
+               topo_top_ind,                                                   &
                wall_flags_total_0
 
     USE kinds
-    
+
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  init_model
-        
+        ONLY:  close_input_file,                                               &
+               coord_ref_sys,                                                  &
+               crs_list,                                                       &
+               get_attribute,                                                  &
+               get_dimension_length,                                           &
+               get_variable,                                                   &
+               init_model,                                                     &
+               input_file_atts,                                                &
+               input_file_vm,                                                  &
+               input_pids_static,                                              &
+               input_pids_vm,                                                  &
+               inquire_fill_value,                                             &
+               open_read_file,                                                 &
+               pids_id
+
     USE pegrid
-    
+
     USE surface_mod,                                                           &
-        ONLY:  surf_lsm_h, surf_usm_h
-        
+        ONLY:  surf_lsm_h,                                                     &
+               surf_usm_h
+
     USE land_surface_model_mod,                                                &
-        ONLY:  nzb_soil, nzs, nzt_soil, zs, t_soil_h, m_soil_h 
-        
-    USE radiation_model_mod
-        
+        ONLY:  m_soil_h,                                                       &
+               nzb_soil,                                                       &
+               nzt_soil,                                                       &
+               t_soil_h,                                                       &
+               zs
+
+    USE radiation_model_mod,                                                   &
+        ONLY:  rad_lw_in,                                                      &
+               rad_lw_out,                                                     &
+               rad_sw_in,                                                      &
+               rad_sw_in_diff,                                                 &
+               rad_sw_out,                                                     &
+               radiation_scheme
+
     USE urban_surface_mod,                                                     &
-        ONLY:  nzb_wall, nzt_wall, t_wall_h 
+        ONLY:  nzb_wall,                                                       &
+               nzt_wall,                                                       &
+               t_wall_h
 
 
     IMPLICIT NONE
-    
+
     TYPE virt_general
-       INTEGER(iwp) ::  id_vm     !< NetCDF file id for virtual measurements
        INTEGER(iwp) ::  nvm = 0   !< number of virtual measurements
     END TYPE virt_general
 
+    TYPE virt_var_atts
+       CHARACTER(LEN=100) ::  coordinates          !< defined longname of the variable
+       CHARACTER(LEN=100) ::  grid_mapping         !< defined longname of the variable
+       CHARACTER(LEN=100) ::  long_name            !< defined longname of the variable
+       CHARACTER(LEN=100) ::  name                 !< variable name
+       CHARACTER(LEN=100) ::  standard_name        !< defined standard name of the variable
+       CHARACTER(LEN=100) ::  units                !< unit of the output variable
+
+       REAL(wp)           ::  fill_value = -9999.0 !< _FillValue attribute
+    END TYPE virt_var_atts
+
     TYPE virt_mea
-    
-       CHARACTER(LEN=100)  ::  feature_type      !< type of the measurement
-       CHARACTER(LEN=100)  ::  filename_original !< name of the original file
-       CHARACTER(LEN=100)  ::  site              !< name of the measurement site
-   
-       CHARACTER(LEN=10), DIMENSION(:), ALLOCATABLE ::  measured_vars_name !< name of the measured variables
-    
-       INTEGER(iwp) ::  ns = 0          !< number of observation coordinates on subdomain, for atmospheric measurements
-       INTEGER(iwp) ::  ns_tot = 0      !< total number of observation coordinates, for atmospheric measurements
-       INTEGER(iwp) ::  ntraj           !< number of trajectories of a measurement
-       INTEGER(iwp) ::  nmeas           !< number of measured variables (atmosphere + soil)
-       
-       INTEGER(iwp) ::  ns_soil = 0     !< number of observation coordinates on subdomain, for soil measurements
-       INTEGER(iwp) ::  ns_soil_tot = 0 !< total number of observation coordinates, for soil measurements
-       
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  dim_t !< number observations individual for each trajectory or station that are no _FillValues
-       
+
+       CHARACTER(LEN=100)  ::  feature_type                     !< type of the real-world measurement
+       CHARACTER(LEN=100)  ::  feature_type_out = 'timeSeries'  !< type of the virtual measurement
+                                                                !< (all will be timeSeries, even trajectories)
+       CHARACTER(LEN=100)  ::  nc_filename                      !< name of the NetCDF output file for the station
+       CHARACTER(LEN=100)  ::  site                             !< name of the measurement site
+
+       CHARACTER(LEN=1000) ::  data_content = REPEAT(' ', 1000) !< string of measured variables (data output only)
+
+       INTEGER(iwp) ::  end_coord_a = 0     !< end coordinate in NetCDF file for local atmosphere observations
+       INTEGER(iwp) ::  end_coord_s = 0     !< end coordinate in NetCDF file for local soil observations
+       INTEGER(iwp) ::  file_time_index = 0 !< time index in NetCDF output file
+       INTEGER(iwp) ::  ns = 0              !< number of observation coordinates on subdomain, for atmospheric measurements
+       INTEGER(iwp) ::  ns_tot = 0          !< total number of observation coordinates, for atmospheric measurements
+       INTEGER(iwp) ::  n_tr_st             !< number of trajectories / station of a measurement
+       INTEGER(iwp) ::  nmeas               !< number of measured variables (atmosphere + soil)
+       INTEGER(iwp) ::  ns_soil = 0         !< number of observation coordinates on subdomain, for soil measurements
+       INTEGER(iwp) ::  ns_soil_tot = 0     !< total number of observation coordinates, for soil measurements
+       INTEGER(iwp) ::  start_coord_a = 0   !< start coordinate in NetCDF file for local atmosphere observations
+       INTEGER(iwp) ::  start_coord_s = 0   !< start coordinate in NetCDF file for local soil observations
+
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  dim_t !< number observations individual for each trajectory 
+                                                         !< or station that are no _FillValues
+
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i       !< grid index for measurement position in x-direction
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j       !< grid index for measurement position in y-direction
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k       !< grid index for measurement position in k-direction
-       
+
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i_soil  !< grid index for measurement position in x-direction
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j_soil  !< grid index for measurement position in y-direction
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k_soil  !< grid index for measurement position in k-direction
-           
+
        LOGICAL ::  trajectory         = .FALSE. !< flag indicating that the observation is a mobile observation
        LOGICAL ::  timseries          = .FALSE. !< flag indicating that the observation is a stationary point measurement
        LOGICAL ::  timseries_profile  = .FALSE. !< flag indicating that the observation is a stationary profile measurement
        LOGICAL ::  soil_sampling      = .FALSE. !< flag indicating that soil state variables were sampled
-       
-       REAL(wp) ::  fill_eutm          !< fill value for UTM coordinates in case of missing values
-       REAL(wp) ::  fill_nutm          !< fill value for UTM coordinates in case of missing values
-       REAL(wp) ::  fill_zag           !< fill value for heigth coordinates in case of missing values 
-       REAL(wp) ::  fillout = -999.9   !< fill value for output in case a observation is taken from inside a building 
-       REAL(wp) ::  origin_x_obs       !< origin of the observation in UTM coordiates in x-direction
-       REAL(wp) ::  origin_y_obs       !< origin of the observation in UTM coordiates in y-direction
-       
-       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  z_ag           !< measurement height above ground level
-       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  depth          !< measurement depth in soil
-             
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  measured_vars       !< measured variables 
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  measured_vars_soil  !< measured variables 
-       
+
+       REAL(wp) ::  fill_eutm                            !< fill value for UTM coordinates in case of missing values
+       REAL(wp) ::  fill_nutm                            !< fill value for UTM coordinates in case of missing values
+       REAL(wp) ::  fill_zar                             !< fill value for heigth coordinates in case of missing values
+       REAL(wp) ::  fillout = -9999.0                    !< fill value for output in case a observation is taken 
+                                                         !< e.g. from inside a building
+       REAL(wp) ::  origin_x_obs                         !< origin of the observation in UTM coordiates in x-direction
+       REAL(wp) ::  origin_y_obs                         !< origin of the observation in UTM coordiates in y-direction
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zar           !< measurement height above ground level
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  depth         !< measurement depth in soil
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  measured_vars       !< measured variables
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  measured_vars_soil  !< measured variables
+
+       TYPE( virt_var_atts ), DIMENSION(:), ALLOCATABLE ::  var_atts !< variable attributes
+
     END TYPE virt_mea
 
     CHARACTER(LEN=5)  ::  char_eutm = "E_UTM"                      !< dimension name for UTM coordinate easting
     CHARACTER(LEN=11) ::  char_feature = "featureType"             !< attribute name for feature type
-    
-    ! This need to generalized
-    CHARACTER(LEN=8)  ::  char_filename = "filename"               !< attribute name for filename
+
+    ! This need to be generalized
+!     CHARACTER(LEN=10) ::  char_fill = '_FillValue'
+    CHARACTER(LEN=9)  ::  char_long = 'long_name'                  !< attribute name for long_name
+    CHARACTER(LEN=13) ::  char_standard = 'standard_name'          !< attribute name for standard_name
+    CHARACTER(LEN=5)  ::  char_unit = 'units'                      !< attribute name for standard_name
     CHARACTER(LEN=11) ::  char_soil = "soil_sample"                !< attribute name for soil sampling indication
-    CHARACTER(LEN=10) ::  char_fillvalue = "_FillValue"            !< variable attribute name for _FillValue 
     CHARACTER(LEN=18) ::  char_mv = "measured_variables"           !< variable name for the array with the measured variable names
     CHARACTER(LEN=5)  ::  char_nutm = "N_UTM"                      !< dimension name for UTM coordinate northing
@@ -216,9 +316,10 @@
     CHARACTER(LEN=8)  ::  char_origy = "origin_y"                  !< attribute name for station coordinate in y
     CHARACTER(LEN=4)  ::  char_site = "site"                       !< attribute name for site name
-    CHARACTER(LEN=19) ::  char_zag = "height_above_ground"         !< attribute name for height above ground variable
+    CHARACTER(LEN=9)  ::  char_station_h = "station_h"             !< variable name indicating height of the site
+    CHARACTER(LEN=1)  ::  char_zar = "z"                           !< attribute name indicating height above reference level
     CHARACTER(LEN=10) ::  type_ts   = 'timeSeries'                 !< name of stationary point measurements
     CHARACTER(LEN=10) ::  type_traj = 'trajectory'                 !< name of line measurements
     CHARACTER(LEN=17) ::  type_tspr = 'timeSeriesProfile'          !< name of stationary profile measurements
-    
+
     CHARACTER(LEN=6), DIMENSION(1:5) ::  soil_vars       = (/                  & !< list of soil variables
                             't_soil',                                          &
@@ -227,106 +328,57 @@
                             'lwcs  ',                                          &
                             'smp   '                       /)
-                            
+
     CHARACTER(LEN=10), DIMENSION(0:1,1:8) ::  chem_vars = RESHAPE( (/          &
                                               'mcpm1     ', 'PM1       ',      &
                                               'mcpm2p5   ', 'PM2.5     ',      &
-                                              'mcpm25    ', 'PM25      ',      &
                                               'mcpm10    ', 'PM10      ',      &
                                               'mfno2     ', 'NO2       ',      &
                                               'mfno      ', 'NO        ',      &
-                                              'tro3      ', 'O3        ',      &
-                                              'mfco      ', 'CO        '       &
+                                              'mcno2     ', 'NO2       ',      &
+                                              'mcno      ', 'NO        ',      &
+                                              'tro3      ', 'O3        '       &
                                                                    /), (/ 2, 8 /) )
-!
-!-- MS: List requires careful revision!
-    CHARACTER(LEN=10), DIMENSION(1:54), PARAMETER ::  list_allowed_variables = & !< variables that can be sampled in PALM
-       (/ 'hfls      ',  & ! surface latent heat flux (W/m2)
-          'hfss      ',  & ! surface sensible heat flux (W/m2)
-          'hur       ',  & ! relative humidity (-)
-          'hus       ',  & ! specific humidity (g/kg)
-          'haa       ',  & ! absolute atmospheric humidity (kg/m3)
-          'mcpm1     ',  & ! mass concentration of PM1 (kg/m3)
-          'mcpm2p5   ',  & ! mass concentration of PM2.5 (kg/m3)
-          'mcpm10    ',  & ! mass concentration of PM10 (kg/m3)
-          'mcco      ',  & ! mass concentration of CO (kg/m3)
-          'mcco2     ',  & ! mass concentration of CO2 (kg/m3)
-          'mcbcda    ',  & ! mass concentration of black carbon paritcles (kg/m3)
-          'ncaa      ',  & ! number concentation of particles (1/m3)
-          'mfco      ',  & ! mole fraction of CO (mol/mol)
-          'mfco2     ',  & ! mole fraction of CO2 (mol/mol)
-          'mfch4     ',  & ! mole fraction of methane (mol/mol)
-          'mfnh3     ',  & ! mole fraction of amonia (mol/mol)
-          'mfno      ',  & ! mole fraction of nitrogen monoxide (mol/mol)
-          'mfno2     ',  & ! mole fraction of nitrogen dioxide (mol/mol)
-          'mfso2     ',  & ! mole fraction of sulfur dioxide (mol/mol)
-          'mfh20     ',  & ! mole fraction of water (mol/mol)
-          'plev      ',  & ! ? air pressure - hydrostaic + perturbation?
-          'rlds      ',  & ! surface downward longwave flux  (W/m2)
-          'rlus      ',  & ! surface upward longwave flux (W/m2)
-          'rsds      ',  & ! surface downward shortwave flux (W/m2)
-          'rsus      ',  & ! surface upward shortwave flux (W/m2)
-          'ta        ',  & ! air temperature (degree C)
-          't_va      ',  & ! virtual accoustic temperature (K)
-          'theta     ',  & ! potential temperature (K)
-          'tro3      ',  & ! mole fraction of ozone air (mol/mol)
-          'ts        ',  & ! scaling parameter of temperature (K)
-          'wspeed    ',  & ! ? wind speed - horizontal?
-          'wdir      ',  & ! wind direction
-          'us        ',  & ! friction velocity
-          'msoil     ',  & ! ? soil moisture - which depth?  
-          'tsoil     ',  & ! ? soil temperature - which depth?                                                                
-          'u         ',  & ! u-component
-          'utheta    ',  & ! total eastward kinematic heat flux
-          'ua        ',  & ! eastward wind (is there any difference to u?)
-          'v         ',  & ! v-component
-          'vtheta    ',  & ! total northward kinematic heat flux
-          'va        ',  & ! northward wind (is there any difference to v?)
-          'w         ',  & ! w-component
-          'wtheta    ',  & ! total vertical kinematic heat flux
-          'rld       ',  & ! downward longwave radiative flux (W/m2)
-          'rlu       ',  & ! upnward longwave radiative flux (W/m2)
-          'rsd       ',  & ! downward shortwave radiative flux (W/m2)
-          'rsu       ',  & ! upward shortwave radiative flux (W/m2)
-          'rsddif    ',  & ! downward shortwave diffuse radiative flux (W/m2)
-          'rnds      ',  & ! surface net downward radiative flux (W/m2)
-          't_soil    ',  &
-          'm_soil    ',  &
-          'lwc       ',  &
-          'lwcs      ',  &
-          'smp       '   &
-       /)
-                                                            
-    
-    LOGICAL ::  global_attribute = .TRUE.         !< flag indicating a global attribute
-    LOGICAL ::  init = .TRUE.                     !< flag indicating initialization of data output
-    LOGICAL ::  use_virtual_measurement = .FALSE. !< Namelist parameter
-
-    REAL(wp) ::  dt_virtual_measurement = 0.0_wp    !< namelist parameter
-    REAL(wp) ::  time_virtual_measurement = 0.0_wp  !< time since last 3d output
-    REAL(wp) ::  vm_time_start = 0.0                !< time after virtual measurements should start
-
-    TYPE( virt_general )                        ::  vmea_general !< data structure which encompass general variables
-    TYPE( virt_mea ), DIMENSION(:), ALLOCATABLE ::  vmea !< virtual measurement data structure
-    
+
+    LOGICAL ::  global_attribute = .TRUE.           !< flag indicating a global attribute
+    LOGICAL ::  initial_write_coordinates = .FALSE. !< flag indicating a global attribute
+    LOGICAL ::  use_virtual_measurement = .FALSE.   !< Namelist parameter
+
+    INTEGER(iwp) ::  maximum_name_length = 32 !< maximum name length of station names
+    INTEGER(iwp) ::  ntimesteps               !< number of timesteps defined in NetCDF output file
+    INTEGER(iwp) ::  ntimesteps_max = 80000   !< number of maximum timesteps defined in NetCDF output file
+    INTEGER(iwp) ::  off_pr = 1               !< number neighboring grid points (in each direction) where virtual profile
+                                              !< measurements shall be taken, in addition to the given coordinates in the driver
+    INTEGER(iwp) ::  off_ts = 1               !< number neighboring grid points (in each direction) where virtual timeseries
+                                              !< measurements shall be taken, in addition to the given coordinates in the driver
+    INTEGER(iwp) ::  off_tr = 1               !< number neighboring grid points (in each direction) where virtual trajectory
+                                              !< measurements shall be taken, in addition to the given coordinates in the driver
+
+    REAL(wp) ::  dt_virtual_measurement = 0.0_wp    !< sampling interval
+    REAL(wp) ::  time_virtual_measurement = 0.0_wp  !< time since last sampling
+    REAL(wp) ::  vm_time_start = 0.0                !< time after which sampling shall start
+
+    TYPE( virt_general )                        ::  vmea_general !< data structure which encompass global variables
+    TYPE( virt_mea ), DIMENSION(:), ALLOCATABLE ::  vmea         !< data structure contain station-specific variables
+
     INTERFACE vm_check_parameters
        MODULE PROCEDURE vm_check_parameters
     END INTERFACE vm_check_parameters
-    
+
     INTERFACE vm_data_output
        MODULE PROCEDURE vm_data_output
     END INTERFACE vm_data_output
-    
+
     INTERFACE vm_init
        MODULE PROCEDURE vm_init
     END INTERFACE vm_init
-    
-    INTERFACE vm_last_actions
-       MODULE PROCEDURE vm_last_actions
-    END INTERFACE vm_last_actions
-    
+
+    INTERFACE vm_init_output
+       MODULE PROCEDURE vm_init_output
+    END INTERFACE vm_init_output
+
     INTERFACE vm_parin
        MODULE PROCEDURE vm_parin
     END INTERFACE vm_parin
-    
+
     INTERFACE vm_sampling
        MODULE PROCEDURE vm_sampling
@@ -339,10 +391,18 @@
 !
 !-- Public interfaces
-    PUBLIC  vm_check_parameters, vm_data_output, vm_init, vm_last_actions,     &
-            vm_parin, vm_sampling
+    PUBLIC  vm_check_parameters,                                               &
+            vm_data_output,                                                    &
+            vm_init,                                                           &
+            vm_init_output,                                                    &
+            vm_parin,                                                          &
+            vm_sampling
 
 !
 !-- Public variables
-    PUBLIC  dt_virtual_measurement, time_virtual_measurement, vmea, vmea_general, vm_time_start
+    PUBLIC  dt_virtual_measurement,                                            &
+            time_virtual_measurement,                                          &
+            vmea,                                                              &
+            vmea_general,                                                      &
+            vm_time_start
 
  CONTAINS
